Index: code/branches/dockingsystem/data/levels/lastManStanding.oxw
===================================================================
--- code/branches/dockingsystem/data/levels/lastManStanding.oxw	(revision 8192)
+++ code/branches/dockingsystem/data/levels/lastManStanding.oxw	(revision 8194)
@@ -1,2 +1,8 @@
+<LevelInfo
+ name = "Last Man Standing"
+ description = "Be the sole survivor."
+ tags = ""
+/>
+
 <?lua
   include("stats.oxo")
@@ -38,29 +44,23 @@
 
 <!-- ------------ middle asteroid -------------- -->
-    <StaticEntity position="0,20,0" collisionType=static>
-       <attached>
-           <Model position="0,0,0" scale=140 mesh="asteroid_UV.mesh" shadow=true />
-           <!-- ParticleEmitter position="0,0,0" source="Orxonox/Steam" / -->
-       </attached>
-      <collisionShapes>
-        <SphereCollisionShape radius="145" />
-      </collisionShapes>
+    <StaticEntity position="0,0,0" collisionType=static>    
+        <attached>
+            <MovableEntity position="0,20,0" rotationrate="-4.5" rotationaxis="0,1,0" >
+                <attached>
+                    <Model position="0,0,0" scale=140 mesh="asteroid_UV.mesh" shadow=true />
+                    <Model position="-160,40,28.4" scale=1 mesh="sphere.mesh" /><!--EasterEgg indicator-->
+                    <PickupSpawner position="-160,40,17" triggerDistance="20" respawnTime="5" maxSpawnedItems="15"><!--EasterEgg-->
+                        <pickup>
+                            <InvisiblePickup template=hugeinvisiblepickup />
+                        </pickup>
+                    </PickupSpawner>
+                </attached>
+            </MovableEntity>
+        </attached>
+        <collisionShapes>
+            <SphereCollisionShape radius="145" />
+        </collisionShapes>
     </StaticEntity>
 
-    <PickupSpawner position="-160,65,10" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
-      <pickup>
-        <InvisiblePickup template=mediuminvisiblepickup />
-      </pickup>
-    </PickupSpawner>
-    <PickupSpawner position="-160,60,17" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
-      <pickup>
-        <InvisiblePickup template=hugeinvisiblepickup />
-      </pickup>
-    </PickupSpawner>
-    <StaticEntity position="-160,60,28.4"><!--EasterEgg-Indicator-->
-      <attached>
-        <Model position="0,0,0" scale=1 mesh="sphere.mesh" />
-      </attached>
-    </StaticEntity>
 
 <!-- ---------------asteroid dome----------------- -->
@@ -138,5 +138,5 @@
 
 
-<?lua end ?>
+<?lua end ?><!-- ---------------asteroid dome END------------------->
 
   </Scene>
Index: code/branches/dockingsystem/data/levels/lastTeamStanding.oxw
===================================================================
--- code/branches/dockingsystem/data/levels/lastTeamStanding.oxw	(revision 8194)
+++ code/branches/dockingsystem/data/levels/lastTeamStanding.oxw	(revision 8194)
@@ -0,0 +1,142 @@
+<LevelInfo
+ name = "Last Team Standing"
+ description = "Survive as a team."
+ tags = "singleplayer"
+/>
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+  include("lastTeamStandingHUD.oxo")
+  include("templates/spaceshipAssff.oxt")
+  include("templates/spaceshipPirate.oxt")
+  include("templates/pickupRepresentationTemplates.oxt")
+?>
+
+<Level
+ name         = "Last Team Standing"
+ description  = "testmap for gametype last team standing"
+ gametype     =  "LastTeamStanding"
+>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/skypanoramagen1"
+  >
+
+    <?lua
+      include("includes/pickups.oxi")
+    ?>
+
+<Bot />
+
+<!-- ------------ middle asteroid -------------- -->
+    <StaticEntity position="0,20,0" collisionType=static>
+       <attached>
+           <Model position="0,0,0" scale=140 mesh="asteroid_UV.mesh" shadow=true />
+           <!-- ParticleEmitter position="0,0,0" source="Orxonox/Steam" / -->
+       </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="145" />
+      </collisionShapes>
+    </StaticEntity>
+
+    <PickupSpawner position="-160,65,10" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
+      <pickup>
+        <InvisiblePickup template=mediuminvisiblepickup />
+      </pickup>
+    </PickupSpawner>
+    <PickupSpawner position="-160,60,17" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
+      <pickup>
+        <InvisiblePickup template=hugeinvisiblepickup />
+      </pickup>
+    </PickupSpawner>
+    <StaticEntity position="-160,60,28.4"><!--EasterEgg-Indicator-->
+      <attached>
+        <Model position="0,0,0" scale=1 mesh="sphere.mesh" />
+      </attached>
+    </StaticEntity>
+
+<!-- ---------------asteroid dome----------------- -->
+<?lua
+max = 16
+for i = 0, max, 1
+do
+    y = math.sin(i/max*6)*750
+    z = math.cos(i/max*6)*750
+    j = 1
+    ?>
+
+    <TeamSpawnPoint team="<?lua print( math.mod(i,4)) ?>" position="<?lua print(y*1.4+z*0.2) ?>,0,<?lua print(z*1.4-y*0.2) ?>" direction="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+
+    <StaticEntity position="<?lua print(y) ?>,0,<?lua print(z) ?>" scale="<?lua print(j * 2) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=15 mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="<?lua print(j * 2) ?>,100,<?lua print(j * 2) ?>" position = "0,0,0" />
+      </collisionShapes>
+    </StaticEntity>
+
+    <StaticEntity position="<?lua print(y) ?>,100,<?lua print(z) ?>" scale="<?lua print(j * 2) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=15 mesh="ast<?lua print( math.mod(i+3,6) + 1) ?>.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="45,100,45" position = "0,0,0" />
+      </collisionShapes>
+    </StaticEntity>
+
+    <StaticEntity position="<?lua print(y) ?>,200,<?lua print(z) ?>" scale="<?lua print(j * 2) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=15 mesh="ast<?lua print( math.mod(i*5,6) + 1) ?>.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="45,100,45" position = "0,0,0" />
+      </collisionShapes>
+    </StaticEntity>
+
+    <StaticEntity position="<?lua print(y) ?>,-100,<?lua print(z) ?>" scale="<?lua print(j * 2) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=15 mesh="ast<?lua print( math.mod(i*13+1,6) + 1) ?>.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="45,100,45" position = "0,0,0" />
+      </collisionShapes>
+    </StaticEntity>
+
+    <StaticEntity position="<?lua print(y) ?>,-200,<?lua print(z) ?>" scale="<?lua print(j * 2) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=15 mesh="ast<?lua print( math.mod(i*17,6) + 1) ?>.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="45,100,45" position = "0,0,0" />
+      </collisionShapes>
+    </StaticEntity>
+
+<!-- ---------Top Asteroid----------- -->
+    <StaticEntity position="<?lua print(y) ?>,300,<?lua print(z) ?>" scale="<?lua print(j * 2.1) ?>" pitch="90" roll="180" yaw="<?lua print(-90+i*360/max) ?>" collisionType=static >
+      <attached>
+        <Model position="0,0,0" scale=25 mesh="ast6.mesh">
+	</Model>
+      </attached>
+      <collisionShapes>
+        <BoxCollisionShape    halfExtents="50,140,30" position="0,0,0"/>
+      </collisionShapes>
+    </StaticEntity>
+
+
+<?lua end ?>
+
+  </Scene>
+</Level>
+
+
Index: code/branches/dockingsystem/data/levels/lastTeamStandingII.oxw
===================================================================
--- code/branches/dockingsystem/data/levels/lastTeamStandingII.oxw	(revision 8194)
+++ code/branches/dockingsystem/data/levels/lastTeamStandingII.oxw	(revision 8194)
@@ -0,0 +1,417 @@
+<LevelInfo
+ name = "On the fly"
+ description = "Survive as a team."
+ tags = ""
+/>
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+  include("lastTeamStandingHUD.oxo")
+  include("templates/spaceshipAssff.oxt")
+  include("templates/spaceshipPirate.oxt")
+  include("templates/pickupRepresentationTemplates.oxt")
+?>
+
+<Level
+ name         = "On the fly"
+ description  = "testmap for gametype last team standing"
+ gametype     =  "LastTeamStanding"
+>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/skypanoramagen1"
+  >
+<!-- TODO:
+1. make collisionshapes bulletproof: -> attach movable entity with dynamic collisionshape within a static collisionshape 
+2. add forcefields -> there should be several "streams" through the level
+3. add teamspawnpoints (different spaceships?) (where should the spawnpoints be placed?)
+-->
+<!--Bot / -->
+
+<!-------------------- Box: TopLayer + BottomLayer + 4 invisible Walls --------------------->
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,-400,0" mesh="cube_orange.mesh" scale3D="1000,10,1000" />
+           <Model position="0,-420,0" mesh="cube_orange.mesh" scale3D="1000,10,1000" /><!-- Second Model in order to avoid graphic errors-->
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,-400,0" halfExtents="1500,10,1500" />
+       </collisionShapes>
+   </StaticEntity>
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,400,0" mesh="cube_orange.mesh" scale3D="1000,10,1000" />
+           <Model position="0,420,0" mesh="cube_orange.mesh" scale3D="1000,10,1000" />
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,400,0" halfExtents="1000,10,1000" />
+       </collisionShapes>
+   </StaticEntity>
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <!--Model position="1000,0,0" mesh="cube_green.mesh" scale3D="10,400,1000" /-->
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="1000,0,0" halfExtents="10,400,1000" />
+       </collisionShapes>
+   </StaticEntity>
+
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <!-- Model position="-1000,0,0" mesh="cube_green.mesh" scale3D="10,400,1000" / -->
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="-1000,0,0" halfExtents="10,400,1000" />
+       </collisionShapes>
+   </StaticEntity>
+
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,1000" mesh="cube_green.mesh" scale3D="1000,400,10" />
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,0,1000" halfExtents="1000,400,10" />
+       </collisionShapes>
+   </StaticEntity>
+
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,-1000" mesh="cube_green.mesh" scale3D="1000,400,10" />
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,0,-1000" halfExtents="1000,400,10" />
+       </collisionShapes>
+   </StaticEntity>
+<!-- END of CUBE-->
+<!-------------- Centered Thin Gate -------------->
+
+   <StaticEntity position="0,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,-1200,0" mesh="hs-w01.mesh" scale3D="300,400,900" pitch="90" roll="0" yaw="0"/>
+           <!--Model position="121,0,-80" mesh="cube.mesh" scale3D="18,400,18" />
+           <Model position="-121,0,-80" mesh="cube.mesh" scale3D="18,400,18" /-->
+           <Model position="0,0,-80" scale=150 mesh="sphere.mesh" />
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="121,0,-80" halfExtents="18,400,18" />
+           <BoxCollisionShape position="-121,0,-80" halfExtents="18,400,18" />
+           <SphereCollisionShape position="0,0,-80" radius="150" />
+       </collisionShapes>
+   </StaticEntity>
+
+   <ForceField position="0,270,-80" direction="-3,-4,-3" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="0,270,-80" direction="-3,-4,-3">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- to bulk gate, left -->
+   <ForceField position="0,-275,-80" direction="3,0,2" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="0,-275,-80" direction="3,0,2">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+
+<!-------------- Bulk Gate -------------->
+   <StaticEntity position="300,0,500" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,-100,0" mesh="hs-w01.mesh" scale3D="500,400,600" pitch="270" roll="0" yaw="0"/>
+           <!--Model position="205,-105,20" mesh="cube.mesh" scale3D="135,280,60" />
+           <Model position="-205,-105,20" mesh="cube.mesh" scale3D="135,280,60" />
+           <Model position="0,235,0" mesh="cube.mesh" scale3D="180,35,35" />
+           <Model position="0,-344,-18" mesh="cube.mesh" scale3D="210,38,36" /-->
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="205,-105,20" halfExtents="135,280,60" />
+           <BoxCollisionShape position="-205,-105,20" halfExtents="135,280,60" />
+           <BoxCollisionShape position="0,235,0" halfExtents="180,35,35" />
+           <BoxCollisionShape position="0,-344,-18" halfExtents="210,38,36" />
+       </collisionShapes>
+   </StaticEntity>
+<!-- back to thin gate -->
+   <ForceField position="300,0,650" direction="1,1.5,-4" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="300,0,650" direction="1,1.5,-4">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- to thin gate -->
+   <ForceField position="300,300,500" direction="-1,0,-2" diameter=100 velocity=1500 length=900 />
+   <MovableEntity position="300,300,500" direction="-1,0,-2">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream -->
+   <ForceField position="830,-300,830" direction="-1,0,0" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="830,-300,830" direction="-1,0,0">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.5,0,0" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.5,0,0" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream II-->
+   <ForceField position="830,350,830" direction="0,0,-1" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="830,350,830" direction="0,0,-1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0,0,0.5" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0,0,0.5" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+
+<!-------------- Bar -------------->
+   <StaticEntity position="-495,0,-495" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,0" mesh="CuboidBody.mesh" scale3D="20,720,20" pitch="90" roll="45" yaw="0"/>
+           <!--Model position="0,0,0" mesh="cube.mesh" scale3D="19,719,19" pitch="90" roll="45" yaw="0"/-->
+       </attached>
+
+       <collisionShapes>
+           <BoxCollisionShape position="0,0,0" halfExtents="20,720,20" pitch="90" roll="45" yaw="0"/>
+       </collisionShapes>
+   </StaticEntity>
+<!-- "lift" -->
+   <ForceField position="-700,-300,-700" direction="0,1,0" diameter=100 velocity=2000 length=400 />
+   <MovableEntity position="-700,-300,-700" direction="0,1,0">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- to thin gate, low -->
+   <ForceField position="0,60,-830" direction="0,-1,2" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="0,60,-830" direction="0,-1,2">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream -->
+   <ForceField position="-830,-350,-830" direction="2,0,0" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="-830,-350,-830" direction="2,0,0">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.5,0,0" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.5,0,0" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream II-->
+   <ForceField position="-870,350,-830" direction="0,0,1" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="-870,350,-830" direction="0,0,1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0,0,0.5" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0,0,0.5" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+<!-------------- 2 Side-Bars -------------->
+   <StaticEntity position="0,0,-1000" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,0" mesh="CuboidBody.mesh" scale3D="20,405,20" pitch="0" roll="10" yaw="0"/>
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,0,0" halfExtents="20,400,20" pitch="0" roll="0" yaw="0"/>
+       </collisionShapes>
+   </StaticEntity>
+   <StaticEntity position="-1000,0,0" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,0" mesh="CuboidBody.mesh" scale3D="20,405,20" pitch="7" roll="0" yaw="0"/>
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,0,0" halfExtents="20,400,20" pitch="0" roll="0" yaw="0"/>
+       </collisionShapes>
+   </StaticEntity>
+<!-- to solar panels -->
+   <ForceField position="-850,-300,-200" direction="1,0,2" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="-850,-300,-200" direction="1,0,2">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- along the bar -->
+   <ForceField position="-900,50,-100" direction="1,0,-1" diameter=150 velocity=2000 length=900 />
+   <MovableEntity position="-900,50,-100" direction="1,0,-1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+<!-------------- 3 Solar Panels --------------->
+
+<?lua
+for i = 1, 3, 1
+do
+    x = i/4*1000
+    z = i/4*500
+?>
+   <StaticEntity position="<?lua print(-1000+x) ?>,-310,<?lua print(z) ?>" direction="0,0,0" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,0,0" mesh="SolarPanel.mesh" scale3D="60,80,30" pitch="0" roll="0" yaw="120"/>
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="0,300,0" halfExtents="155,460,3" pitch="0" roll="0" yaw="120"/>
+       </collisionShapes>
+   </StaticEntity>
+<?lua end ?>
+
+   <ForceField position="-600,100,400" direction="0,-1,-3" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="-600,100,400" direction="0,-1,-3">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream -->
+   <ForceField position="-830,-100,830" direction="0,0,-1" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="-830,-100,830" direction="0,0,-1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.5,0,0" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.5,0,0" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream II -->
+   <ForceField position="-830,350,830" direction="1,0,0" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="-830,350,830" direction="1,0,0">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0,0,0.5" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0,0,0.5" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- along the panels -->
+   <ForceField position="-830,250,250" direction="3,0,2" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="-830,250,250" direction="3,0,2">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+<!-------------- Thin Gate -------------->
+
+   <StaticEntity position="500,0,-500" direction="1,0,-1" collisionType=static mass=100000 >
+       <attached>
+           <Model position="0,-1200,0" mesh="hs-w01.mesh" scale3D="300,400,900" pitch="90" roll="0" yaw="0"/>
+           <Model position="0,100,-80" scale=150 mesh="sphere.mesh" />
+       </attached>
+       <collisionShapes>
+           <BoxCollisionShape position="121,0,-80" halfExtents="18,400,18" />
+           <BoxCollisionShape position="-121,0,-80" halfExtents="18,400,18" />
+           <SphereCollisionShape position="0,100,-80" radius="150" />
+       </collisionShapes>
+   </StaticEntity>
+<!-- to thin gate middle -->
+   <ForceField position="550,350,-550" direction="-3.3,0,3" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="550,350,-550" direction="-3.3,0,3">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- across the field -->
+   <ForceField position="550,-350,-550" direction="-3,0,1" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="550,-350,-550" direction="-3,0,1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.7,0.4,0.1" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.7,0.4,0.1" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream -->
+   <ForceField position="830,-350,-830" direction="0,0,1" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="830,-350,-830" direction="0,0,1">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0.5,0,0" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0.5,0,0" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+<!-- alternative stream II -->
+   <ForceField position="830,350,-830" direction="-1,0,0" diameter=100 velocity=2000 length=900 />
+   <MovableEntity position="830,350,-830" direction="-1,0,0">
+       <attached>
+           <Billboard position="0,0,0" material="Flares/ringflare2" colour="0,0,0.5" scale=1/>
+           <?lua for i=0,4,1 do ?>
+               <Billboard position="0,0,<?lua print(i*(-100)) ?>" material="Examples/Flare" colour="0,0,0.5" scale=1/>
+           <?lua end ?>
+       </attached>
+   </MovableEntity>
+
+<!---------------- Spawnpoints ------------------>
+    <TeamSpawnPoint team=0 position="845,350,-835" direction="-1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=0 position="845,-350,-835" direction="0,0,1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=0 position="835,350,-845" direction="-1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=0 position="835,-350,-845" direction="0,0,1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+
+    <TeamSpawnPoint team=1 position="-845,350,835" direction="1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=1 position="-845,-100,835" direction="0,0,-1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=1 position="-835,350,845" direction="1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=1 position="-835,-100,845" direction="0,0,-1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+
+    <TeamSpawnPoint team=2 position="-870,350,-835" direction="0,0,1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=2 position="-840,-350,-835" direction="1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=2 position="-865,350,-840" direction="0,0,1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=2 position="-835,-350,-840" direction="1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+
+    <TeamSpawnPoint team=3 position="835,350,845" direction="0,0,-1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=3 position="835,-300,845" direction="-1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=3 position="845,350,835" direction="0,0,-1" spawnclass=SpaceShip pawndesign=spaceshipassff />
+    <TeamSpawnPoint team=3 position="845,-300,835" direction="-1,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff />
+<Bot />
+
+  </Scene>
+</Level>
+